<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- path-probe.qdoc -->
  <title>PathProbe QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">PathProbe QML Type</h1>
<span class="subtitle"></span>
<!-- $$$PathProbe-brief -->
<p>Locates files outside the project. <a href="#details">More...</a></p>
<!-- @@@PathProbe -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import  </td></tr><tr><td class="memItemLeft rightAlign topAlign"> Inherited By:</td><td class="memItemRight bottomAlign"> <p><a href="qml-binaryprobe.html">BinaryProbe</a>, <a href="qml-frameworkprobe.html">FrameworkProbe</a>, and <a href="qml-includeprobe.html">IncludeProbe</a></p>
</td></tr></table></div><ul>
<li><a href="qml-pathprobe-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-pathprobe.html#allResults-prop">allResults</a></b></b> : varList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#candidateFilter-prop">candidateFilter</a></b></b> : var</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#candidatePaths-prop">candidatePaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#environmentPaths-prop">environmentPaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#fileName-prop">fileName</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#filePath-prop">filePath</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#nameFilter-prop">nameFilter</a></b></b> : script</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#nameSuffixes-prop">nameSuffixes</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#names-prop">names</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#path-prop">path</a></b></b> : string</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#pathSuffixes-prop">pathSuffixes</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#platformEnvironmentPaths-prop">platformEnvironmentPaths</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#platformSearchPaths-prop">platformSearchPaths</a></b></b> : pathList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#searchPaths-prop">searchPaths</a></b></b> : pathList</li>
<li class="fn"><b><b><a href="qml-pathprobe.html#selectors-prop">selectors</a></b></b> : varList</li>
</ul>
<!-- $$$PathProbe-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>Finds files that have the specified file name suffix, such as <i>.exe</i>, from the specified locations.</p>
<p>PathProbe takes as input lists of paths to search files from and file name patterns. The paths are specified by using the <a href="qml-pathprobe.html#searchPaths-prop">searchPaths</a>, <a href="qml-pathprobe.html#platformSearchPaths-prop">platformSearchPaths</a>, <a href="qml-pathprobe.html#environmentPaths-prop">environmentPaths</a>, and <a href="qml-pathprobe.html#platformEnvironmentPaths-prop">platformEnvironmentPaths</a> properties. The file name patterns are specified by the <a href="qml-pathprobe.html#names-prop">names</a> and <a href="qml-pathprobe.html#nameSuffixes-prop">nameSuffixes</a> properties. Returns the first file that matches the file name patterns. If no such file is found, the <a href="qml-qbslanguageitems-probe.html#found-prop">probe.found</a> property is set to <code>false</code>.</p>
<p>For example, a simple PathProbe that searches for the stdio.h header can be used as follows:</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;cpp&quot;</span> }
      PathProbe {
          id: probe
          pathSuffixes: <span class="operator">[</span><span class="string">&quot;include&quot;</span><span class="operator">]</span>
          names: <span class="operator">[</span><span class="string">&quot;stdio.h&quot;</span><span class="operator">]</span>
      }
      cpp<span class="operator">.</span>includePaths: probe<span class="operator">.</span>found <span class="operator">?</span> <span class="operator">[</span>probe<span class="operator">.</span>path<span class="operator">]</span> : <span class="operator">[</span><span class="operator">]</span>
  }

</pre>
<!-- @@@PathProbe -->
<h2>Property Documentation</h2>
<!-- $$$allResults -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="allResults-prop">
<td class="tblQmlPropNode"><p>
<span class="name">allResults</span> : <span class="type">varList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property contains the list of objects, each object representing a single found file:</p>
<pre class="cpp">

  {
      found: <span class="keyword">true</span><span class="operator">,</span>
      candidatePaths: <span class="operator">[</span><span class="string">&quot;path1/to/file&quot;</span><span class="operator">,</span> <span class="string">&quot;path2/to/file&quot;</span><span class="operator">,</span> <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span><span class="operator">]</span>
      filePath: <span class="string">&quot;path/to/file&quot;</span>
      fileName: <span class="string">&quot;file&quot;</span>
      path: <span class="string">&quot;path/to&quot;</span>
  }

</pre>
<p><b>See also </b><a href="qml-pathprobe.html#filePath-prop">filePath</a>, <a href="qml-pathprobe.html#fileName-prop">fileName</a>, and <a href="qml-pathprobe.html#path-prop">path</a>.</p>
</div></div><!-- @@@allResults -->
<br/>
<!-- $$$candidateFilter -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="candidateFilter-prop">
<td class="tblQmlPropNode"><p>
<span class="name">candidateFilter</span> : <span class="type">var</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property holds the function that can be used to filter out unsuitable candidates. For example, when searching for a library, it might be necessary to check its architecture:</p>
<pre class="cpp">

  PathProbe {
      pathSuffixes: <span class="operator">[</span><span class="string">&quot;*.so&quot;</span><span class="operator">,</span> <span class="operator">*</span><span class="operator">.</span>dll<span class="operator">]</span>
      candidateFilter: {
          function getLibraryArchitecture(file) { <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span> }
          <span class="keyword">return</span> function(file) {
              <span class="keyword">return</span> Utilities<span class="operator">.</span>isSharedLibrary(file)
                      <span class="operator">&amp;</span><span class="operator">&amp;</span> getLibraryArchitecture(file) <span class="operator">=</span><span class="operator">=</span> qbs<span class="operator">.</span>architecture;
          }
      }
  }

</pre>
</div></div><!-- @@@candidateFilter -->
<br/>
<!-- $$$candidatePaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="candidatePaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">candidatePaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property contains the result list of all paths that were checked before a file was found (including the file names).</p>
<p>Default: Undefined</p>
</div></div><!-- @@@candidatePaths -->
<br/>
<!-- $$$environmentPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="environmentPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">environmentPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of environment variables that contains paths where to search files. Paths in the environment variable should be separated using <a href="qml-qbsmodules-qbs.html#pathListSeparator-prop">qbs.pathListSeparator</a>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@environmentPaths -->
<br/>
<!-- $$$fileName -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="fileName-prop">
<td class="tblQmlPropNode"><p>
<span class="name">fileName</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property contains the found file's name (excluding the path).</p>
<p>Default: Undefined</p>
</div></div><!-- @@@fileName -->
<br/>
<!-- $$$filePath -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="filePath-prop">
<td class="tblQmlPropNode"><p>
<span class="name">filePath</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property contains the full path to the found file, including the file name.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@filePath -->
<br/>
<!-- $$$nameFilter -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="nameFilter-prop">
<td class="tblQmlPropNode"><p>
<span class="name">nameFilter</span> : <span class="type">script</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A script that is executed for each file name before prepending file suffixes. Can be used to transform file names.</p>
</div></div><!-- @@@nameFilter -->
<br/>
<!-- $$$nameSuffixes -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="nameSuffixes-prop">
<td class="tblQmlPropNode"><p>
<span class="name">nameSuffixes</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of file suffixes to search for. These suffixes are appended to every file name passed via the <a href="qml-pathprobe.html#names-prop">names</a> property.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@nameSuffixes -->
<br/>
<!-- $$$names -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="names-prop">
<td class="tblQmlPropNode"><p>
<span class="name">names</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of file names to search for.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@names -->
<br/>
<!-- $$$path -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="path-prop">
<td class="tblQmlPropNode"><p>
<span class="name">path</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property contains the full path where the found file is located (that is, the file directory).</p>
<p>Default: Undefined</p>
</div></div><!-- @@@path -->
<br/>
<!-- $$$pathSuffixes -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="pathSuffixes-prop">
<td class="tblQmlPropNode"><p>
<span class="name">pathSuffixes</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of relative paths that are appended to each path where <a href="qml-pathprobe.html">PathProbe</a> searches for files. That is, the file should be located within one of the subfolders passed using this property.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@pathSuffixes -->
<br/>
<!-- $$$platformEnvironmentPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="platformEnvironmentPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">platformEnvironmentPaths</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of platform environment variables that contains paths where to search files. Paths in the environment variable should be separated using <a href="qml-qbsmodules-qbs.html#pathListSeparator-prop">qbs.pathListSeparator</a>.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@platformEnvironmentPaths -->
<br/>
<!-- $$$platformSearchPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="platformSearchPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">platformSearchPaths</span> : <span class="type">pathList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of platform paths where to search files.</p>
<p>Default: <code>['/usr', '/usr/local']</code> on Unix hosts, empty otherwise</p>
</div></div><!-- @@@platformSearchPaths -->
<br/>
<!-- $$$searchPaths -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="searchPaths-prop">
<td class="tblQmlPropNode"><p>
<span class="name">searchPaths</span> : <span class="type">pathList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The list of paths where to search files.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@searchPaths -->
<br/>
<!-- $$$selectors -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="selectors-prop">
<td class="tblQmlPropNode"><p>
<span class="name">selectors</span> : <span class="type">varList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property should be used to search for multiple files. It contains the list of selectors each of which describes a single file to search for. A selector can be either a string, a stringList, or a dictionary.</p>
<p>The following example searches for three files and illustrates different ways to specify selectors:</p>
<pre class="cpp">

  selectors: <span class="operator">[</span>
      <span class="comment">// 1st file with a single name</span>
      <span class="string">&quot;header.h&quot;</span><span class="operator">,</span>
      <span class="comment">// 2nd file with possible name variants</span>
      <span class="operator">[</span><span class="string">&quot;config.h&quot;</span><span class="operator">,</span> <span class="string">&quot;foo-config.h&quot;</span><span class="operator">,</span> <span class="string">&quot;bar-config.h&quot;</span><span class="operator">]</span><span class="operator">,</span>
      <span class="comment">// 3rd file with possible name and suffix variants</span>
      {names: <span class="operator">[</span><span class="string">&quot;footk&quot;</span><span class="operator">,</span> <span class="string">&quot;footk-version&quot;</span><span class="operator">]</span><span class="operator">,</span> nameSuffixes: <span class="operator">[</span><span class="string">&quot;.h&quot;</span><span class="operator">,</span> <span class="string">&quot;.hpp&quot;</span><span class="operator">]</span>}
  <span class="operator">]</span>

</pre>
</div></div><!-- @@@selectors -->
<br/>
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
